package org.implab.gradle.containers;

import org.gradle.api.file.DirectoryProperty;
import org.gradle.api.file.ProjectLayout;
import org.gradle.api.file.RegularFileProperty;
import org.gradle.api.model.ObjectFactory;
import org.gradle.api.provider.Property;

public class ContainerExtension {

    private final Property<String> cliCmd;

    private final Property<String> imageAuthority;

    private final Property<String> imageGroup;

    private final DirectoryProperty contextDir;

    private final RegularFileProperty imageIdFile;

    public ContainerExtension(ObjectFactory factory, ProjectLayout layout) {
        contextDir = factory.directoryProperty();
        contextDir.convention(layout.getBuildDirectory().dir("context"));

        imageIdFile = factory.fileProperty();
        imageIdFile.convention(layout.getBuildDirectory().file("imageId"));

        cliCmd = factory.property(String.class);
        cliCmd.set("docker");

        imageAuthority = factory.property(String.class);
        imageGroup = factory.property(String.class);
    }

    public Property<String> getCliCmd() {
        return cliCmd;
    }

    public void setCliCmd(String cliCmd) {
        this.cliCmd.set(cliCmd);
    }

    public DirectoryProperty getContextDirectory() {
        return contextDir;
    }

    public RegularFileProperty getImageIdFile() {
        return imageIdFile;
    }

    public Property<String> getImageAuthority() {
        return imageAuthority;
    }

    public Property<String> getImageGroup() {
        return imageGroup;
    }
}